%define rhugversion 20031215
%define rhugsource1 xerces-%(echo %{version} | sed 's:\\.:_:g') upstream
%define rhugpatches 2 3 4

Summary: The Xerces XML parser
Name: xerces-j
Version: 2.2.1
Release: 16
URL: http://xml.apache.org/xerces2-j/
Source: rhug-xerces-%{rhugversion}.tar.bz2
Source1: Xerces-J-src.%{version}.tar.gz
Patch1: %{name}-rhjpp.patch
Patch2: %{name}-nag13282.patch
Patch3: %{name}-pr9547.patch
Patch4: %{name}-pr8823.patch
License: Apache Software License
Group: System Environment/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: gcc34-c++
BuildPrereq: gcc34-java >= 3.4.0-1
Prereq: redhat-java-rpm-scripts >= 1.0.3-1
Requires: libgcj34 >= 3.4.0-1

%description
Xerces (named after the Xerces Blue butterfly) provides world-class
XML parsing and generation. Fully-validating parsers are available for
both Java and C++, implementing the W3C XML and DOM (Level 1 and 2)
standards, as well as the de facto SAX (version 2) standard. The
parsers are highly modular and configurable. Initial support for XML
Schema (draft W3C standard) is also provided.

%package devel
Summary: CNI headers for developing Xerces applications
Group: Development/Libraries
Requires: xerces-j = %{version}-%{release}

%description devel
The xerces-j-devel package contains the headers required to develop
Cygnus Native Interface (CNI) extensions that use Xerces.

%prep
%setup -q -a 1
mv %{rhugsource1}
%patch1 -p0 -b .rhjpp
%patch2 -p0 -b .nag13282
%patch3 -p1 -b .pr9547
%patch4 -p0 -b .pr8823
mv ChangeLog ChangeLog.rhug
for f in Version.java; do
    f=upstream/src/org/apache/xerces/impl/$f
    sed -e "s:@@VERSION@@:Xerces-J %{version}-%{release}:g" \
	< $f > $f.tmp && mv -f $f.tmp $f
done

%build
CC=gcc34 CXX=g++34 GCJ=gcj34 GCJH=gcjh34 \
./configure \
    --disable-static \
    --prefix=%{_prefix} \
    --libdir=%{_libdir}
make

%install
rm -rf ${RPM_BUILD_ROOT}
%makeinstall
rm -f ${RPM_BUILD_ROOT}%{_libdir}/*.la
find ${RPM_BUILD_ROOT}%{_libdir} -type l | xargs rm -f
mkdir ${RPM_BUILD_ROOT}%{_libdir}/%{name}

%post
%{_sbindir}/javaconfig \
    %{_libdir}/lib-javax-xml-parsers.so \
    %{_libdir}/lib-org-apache-html.so \
    %{_libdir}/lib-org-apache-wml.so \
    %{_libdir}/lib-org-apache-xerces.so \
    %{_libdir}/%{name}/lib-org-w3c-dom.so \
    %{_libdir}/%{name}/lib-org-xml-sax.so \
    %{_datadir}/java/xmlParserAPIs.jar \
    %{_datadir}/java/xercesImpl.jar

%preun
for f in lib-org-w3c-dom.so lib-org-xml-sax.so; do
    f=%{_libdir}/%{name}/$f
    [ -L $f ] && rm -f $f
done

%postun
%{_sbindir}/javaconfig \
    %{_libdir}/lib-javax-xml-parsers.so \
    %{_libdir}/lib-org-apache-html.so \
    %{_libdir}/lib-org-apache-wml.so \
    %{_libdir}/lib-org-apache-xerces.so \
    %{_libdir}/%{name}/lib-org-w3c-dom.so \
    %{_libdir}/%{name}/lib-org-xml-sax.so \
    %{_datadir}/java/xmlParserAPIs.jar \
    %{_datadir}/java/xercesImpl.jar
 
%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc *.rhug upstream/{LICENSE,ISSUES,README,Readme.html,STATUS,TODO}
%doc upstream/{docs,data,samples}
%{_libdir}/*.so
%{_libdir}/%{name}
%{_datadir}/java/*.jar

%files devel
%defattr(-,root,root)
%{_includedir}/javax/xml/parsers
%{_includedir}/org/apache/html
%{_includedir}/org/apache/wml
%{_includedir}/org/apache/xerces
%{_includedir}/org/apache/xml/serialize
%{_includedir}/org/w3c/dom
%{_includedir}/org/xml/sax

%changelog
* Tue May  4 2004 Gary Benson <gbenson@redhat.com> 2.2.1-16
- Rebuild with new compiler.

* Thu Apr 15 2004 Gary Benson <gbenson@redhat.com> 2.2.1-15
- Rebuild with new compiler (#120844).

* Tue Mar  2 2004 Elliot Lee <sopwith@redhat.com>
- Rebuilt.

* Thu Feb 19 2004 Gary Benson <gbenson@redhat.com> 2.2.1-14
- Delete links correctly in preun scriptlet.

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com> 2.2.1-13
- Rebuilt.

* Thu Feb 12 2004 Gary Benson <gbenson@redhat.com> 2.2.1-12
- Rebuild for Fedora.

* Fri Jan 30 2004 Gary Benson <gbenson@redhat.com>
- Move lib-org-w3c-dom.so and lib-org-xml-sax.so symlinks into a
  subdirectory of %{_libdir} to avoid conflicting with libgcj.

* Mon Dec 15 2003 Gary Benson <gbenson@redhat.com>
- Apply hammer multilib fix to all multilib archs.
- Correctly link local libraries on hammer.

* Tue Dec  9 2003 Gary Benson <gbenson@redhat.com>
- Upgraded to fluorinated RHUG tarball.
- Removed lib-org-apache-xml-serialize.so compatibility library.
- Split xerces.jar into xmlParserAPIs.jar and xercesImpl.jar.
- Picked up some omitted resources in META-INF.

* Wed Sep 24 2003 Gary Benson <gbenson@redhat.com> 2.2.1-11
- Add a missing resource from lib-org-apache-xml-serialize.so.

* Fri Sep 19 2003 Gary Benson <gbenson@redhat.com> 2.2.1-10
- Substitute @@VERSION@@ into the file that needs it.
- Merge libraries to avoid unresolved symbols caused by broken
  circular dependencies.

* Fri Sep  5 2003 Gary Benson <gbenson@redhat.com> 2.2.1-9
- Ensure we have a working javaconfig.

* Thu Sep  4 2003 Gary Benson <gbenson@redhat.com>
- Remove workarounds used to support alpha releases.

* Fri Aug 15 2003 Gary Benson <gbenson@redhat.com> 2.2.1-8
- Rebuild with new compiler.

* Mon Aug 11 2003 Gary Benson <gbenson@redhat.com> 2.2.1-7
- Remove optimiser failure workaround.

* Tue Aug  5 2003 Gary Benson <gbenson@redhat.com> 2.2.1-6
- Rebuild with new compiler.

* Mon Jul 28 2003 Gary Benson <gbenson@redhat.com> 2.2.1-5
- Add missing resources to jarfile (#100977).

* Fri Jul 25 2003 Gary Benson <gbenson@redhat.com>
- Move everything but the CNI includes out of the -devel subpackage.
- Clarify the -devel subpackage's summary and description.
- Remove unnecessary -devel build-time dependencies (#99077).

* Mon Jun 30 2003 Gary Benson <gbenson@redhat.com> 2.2.1-4
- Rebuild with new compiler and enable ia64 build.

* Fri Jun  6 2003 Gary Benson <gbenson@redhat.com> 2.2.1-3
- Rebuild with new compiler.

* Thu Jun  5 2003 Gary Benson <gbenson@redhat.com>
- Add build time dependency on C++ compiler.

* Thu May 29 2003 Gary Benson <gbenson@redhat.com> 2.2.1-2
- Rebuild with new compiler.

* Thu May 22 2003 Gary Benson <gbenson@redhat.com> 2.2.1-1
- Renamed from xerces to xerces-j.
- Move unversioned library symlinks into main package.

* Fri May  2 2003 Tom Tromey <tromey@redhat.com> 2.2.1-9
- Rebuild with new compiler.

* Fri Apr 11 2003 Gary Benson <gbenson@redhat.com> 2.2.1-8
- Fix linking on hammer.

* Wed Apr  9 2003 Gary Benson <gbenson@redhat.com> 2.2.1-7
- Compile resources with libtool to enable hammer builds.

* Tue Apr  8 2003 Gary Benson <gbenson@redhat.com>
- Rename serialize patch to pr8823 patch.

* Fri Apr  4 2003 Gary Benson <gbenson@redhat.com>
- Rename libtool patch to relink patch.

* Tue Apr  1 2003 Gary Benson <gbenson@redhat.com> 2.2.1-6
- Rearrange the order in which libraries are linked together (again).
- Remove the ignore-errors part of the libtool patch.

* Fri Mar 28 2003 Tom Tromey <tromey@redhat.com> 2.2.1-5
- Apply libtool no-relink patch.

* Fri Mar 28 2003 Gary Benson <gbenson@redhat.com> 2.2.1-4
- Rearrange the order in which libraries are linked together.

* Thu Mar 27 2003 Gary Benson <gbenson@redhat.com> 2.2.1-3
- Tighten up directory ownership in %{_includedir}.

* Thu Mar 27 2003 Gary Benson <gbenson@redhat.com> 2.2.1-2
- Rebuild with new compiler.
- Package up all built libraries.

* Thu Mar 20 2003 Gary Benson <gbenson@redhat.com> 2.2.1-1
- Initial Red Hat Linux build.

* Sat Mar  2 2002 Anthony Green <green@redhat.com>
- Initial RHUG build.
